struct pcg_solver {
  pcg_solver (const csr<Float>& a1) : a(a1), m(ic0(a1)) {}
  vec<Float> solve (const vec<Float>& b) const {
    size_t max_iter = 10000;
    Float tol = 1e-15;
    vec<Float> x (b.size(), 0.0);
    int status = pcg (a, x, b, m, max_iter, tol);
    return x;
  }
  csr<Float> a;
  basic_ic0<Float> m;
}; 
