// file automatically generated by "../../../rheolef/nfem/basis/basis_symbolic_cxx.cc"
///
/// This file is part of Rheolef.
///
/// Copyright (C) 2000-2009 Pierre Saramito <Pierre.Saramito@imag.fr>
///
/// Rheolef is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.
///
/// Rheolef is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.
///
/// You should have received a copy of the GNU General Public License
/// along with Rheolef; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
///
/// =========================================================================
#ifndef _RHEOLEF_P0_H
#define _RHEOLEF_P0_H
#include "rheolef/basis.h"
#include "rheolef/tensor.h"
namespace rheolef {

class basis_P0: public basis_rep {
public:
  typedef size_t size_type;
  basis_P0() : basis_rep("P0", element_constant::Lagrange) {}
  ~basis_P0();
  size_type degree () const;
  size_type size (
    reference_element hat_K, basis_rep::dof_family_type family) const;
  dof_family_type dof_family(
    reference_element hat_K,
    size_type    i_dof_local) const;
  Float eval(
    reference_element hat_K,
    size_type         i_dof_local,
    const point&      hat_x) const;
  point grad_eval(
    reference_element hat_K,
    size_type         i_dof_local,
    const point&      hat_x) const;
  tensor hessian_eval(
    reference_element hat_K,
    size_type         i_dof_local,
    const point&      hat_x) const;
  void eval(
    reference_element hat_K,
    const point&      hat_x,
    std::vector<Float>&    values) const;
  void grad_eval(
    reference_element hat_K,
    const point&      hat_x,
    std::vector<point>&    values) const;
  void hessian_eval(
    reference_element hat_K,
    const point&      hat_x,
    std::vector<tensor >&    values) const;
  void hat_node(
    reference_element hat_K,
    std::vector<point>&    hat_node) const;
};
} // namespace rheoef
#endif // _RHEOLEF_P0_H

